<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: b771c98abdb0 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-03-25 08:49 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_chooser_base{
	/** @var we_database_base */
	protected $db;

	/** @var string */
	protected $table = FILE_TABLE;

	/** @var bool */
	protected $onchangeSetHot = true;

	/** @var bool */
	protected $isEditable = false;

	/** @var bool */
	protected $CanDelete = false;

	/** @var string */
	protected $extraDelFn = '';

	function setOnchangeSetHot(bool $setHot = true): void{
		$this->onchangeSetHot = $setHot;
	}

	function getJsSetHot(): string{
		return $this->onchangeSetHot ? "we_cmd('setHot');" : '';
	}

	/**
	 * @param bool $val
	 * @return static
	 */
	public function setEditable(bool $val){
		$this->isEditable = $val;
		return $this;
	}

	/**
	 * @param bool $val
	 * @return static
	 */
	public function setDeletable(bool $val){
		$this->CanDelete = $val;
		return $this;
	}

}
