<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 3d882708e829 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-09-02 17:14 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

class we_exim_refData{
	/** @var int */
	var $ID;

	/** @var int */
	var $ParentID;

	/** @var int */
	var $TemplateID;

	/** @var string */
	var $Table;

	/** @var string */
	var $Path;

	/** @var string */
	var $ContentType;

	/** @var int */
	var $DocType;

	/** @var string */
	var $Category;

	/** @var int */
	var $OldID;

	/** @var int */
	var $OldParentID;

	/** @var string */
	var $OldPath;

	/** @var string */
	var $OldTemplatePath;

	/** @var string */
	public $OldDocTypeName;

	/** @var bool */
	var $Examined = false;

	/** @var int */
	var $elements = 0;

	/** @var int */
	var $level = 0;

	/** @var string[] */
	private $slots = ['ID', 'ParentID', 'Path', 'Table', 'ContentType', 'TemplateID', 'DocType', 'Category'];

	function init(we_base_mainmodel $object, array $extra = []): void{
		foreach($this->slots as $slot){
			if(isset($object->$slot)){
				$this->{$slot} = $object->$slot;
			}
		}
		foreach($extra as $ek => $ev){
			$this->{$ek} = $ev;
		}
	}

	function match(array $param): bool{
		foreach($param as $k => $v){
			if($k != 'level' && $this->{$k} != $v){
				return false;
			}
		}
		return true;
	}

	public function __sleep(): array{
		$tmp = get_object_vars($this);
		unset($tmp['elements']);
		return array_keys($tmp);
	}

}
