<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 6cc64d37551c $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-07-25 11:32 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_folder_vfile extends we_folder_base{
	/** @var int */
	public $remClass = 0;

	/** @var string database table in which the object is stored */
	public $Table = VFILE_TABLE;

	/** @var string ContentType of the Object  */
	public $ContentType = we_base_ContentTypes::FOLDER_VFILE;

	public function __construct($id = 0){
		parent::__construct($id);
	}

	/** initializes all data not static in class and not saved by persistent slots/elements.
	 * This is called from constructor and __wakeup on serialized documents
	 */
	protected function initStatic(): void{
		parent::initStatic();
		$this->persistent_slots = array_merge($this->persistent_slots, [
			'remClass' => we_base_request::INT,
		]);
	}

	protected function hasCopyPerm(): bool{
		return false;
	}

}
