<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 0cf51d7ece55 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-04-09 00:44 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

/**
 * class to handle hooks in webEdition and in applications
 */
abstract class we_hook_base{
	/** @var we_hook_handler */
	protected $hookHandler;

	/** @var array */
	protected $params;

	public function __construct(we_hook_handler $handler, array $params){
		$this->hookHandler = $handler;
		$this->params = &$params;
	}

	/**
	 * @return bool false on error
	 */
	abstract public function execute(): bool;
}
