<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: d5bcf73330c9 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-12-28 19:06 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_tr extends we_weTag_tag{

	public static function parse(array $attribs, string $content): string{
		//NOTE: _type is an internal attribute.
		return '<?= ' . we_weTag_parser::printTag('tr', ['_type' => 'start']) . ';?>' . $content . '<?= ' . we_weTag_parser::printTag('tr', ['_type' => 'end']) . ';?>';
	}

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): string{
		if(empty(we_tag_listview::$current)){
			return self::parseError('not in lv', __CLASS__);
		}
		switch(self::getAttribute('_type', $attribs, '', we_base_request::STRING)){
			case 'start':
				return (we_tag_listview::$current->shouldPrintStartTR() ? self::htmlTag('tr', self::removeAttribs($attribs, ['_type']), '', false, true) : '');
			case 'end':
				return (we_tag_listview::$current->shouldPrintEndTR() ? '</tr>' : '');
		}
		return '';
	}

}
