<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 02a1ba0c8f01 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-08-12 16:37 +0200 $
 */
class we_tw_captcha extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName, true);

		$this->NeedsEndTag = false;

		$this->Attributes = [
			new we_weTag_textAttribute('width', true, ''),
			new we_weTag_textAttribute('height', true, ''),
			new we_weTag_textAttribute('maxlength', false, ''),
			new we_weTag_selectAttribute('subset', [
				new we_weTag_option('alphanum'),
				new we_weTag_option('alpha'),
				new we_weTag_option('num'),
				], false, ''),
			new we_weTag_textAttribute('skip', false, ''),
			new we_weTag_choiceAttribute('fontcolor', [
				new we_weTag_option('#000000'),
				new we_weTag_option('#ffffff'),
				new we_weTag_option('#ff0000'),
				new we_weTag_option('#00ff00'),
				new we_weTag_option('#0000ff'),
				new we_weTag_option('#ffff00'),
				new we_weTag_option('#ff00ff'),
				new we_weTag_option('#00ffff'),
				], false, true),
			new we_weTag_textAttribute('fontsize', false, ''),
			new we_weTag_choiceAttribute('bgcolor', [
				new we_weTag_option('#ffffff'),
				new we_weTag_option('#cccccc'),
				new we_weTag_option('#888888'),
				], false, false),
			new we_weTag_selectAttribute('transparent', we_weTag_selectAttribute::getTrueFalse(true)),
			new we_weTag_choiceAttribute('style', [
				new we_weTag_option('strikeout'),
				new we_weTag_option('fullcircle'),
				new we_weTag_option('fullrectangle'),
				new we_weTag_option('outlinecircle'),
				new we_weTag_option('outlinerectangle'),
				], false, true),
			new we_weTag_choiceAttribute('stylecolor', [
				new we_weTag_option('#cccccc'),
				new we_weTag_option('#ff0000'),
				new we_weTag_option('#00ff00'),
				new we_weTag_option('#0000ff'),
				new we_weTag_option('#00ffff'),
				new we_weTag_option('#ff00ff'),
				new we_weTag_option('#ffff00'),
				], false, true),
			new we_weTag_textAttribute('angle', false, ''),
			new we_weTag_selectAttribute('align', [
				new we_weTag_option('random'),
				new we_weTag_option('center'),
				new we_weTag_option('left'),
				new we_weTag_option('right'),
				], false, ''),
			new we_weTag_selectAttribute('valign', [
				new we_weTag_option('random'),
				new we_weTag_option('top'),
				new we_weTag_option('middle'),
				new we_weTag_option('bottom'),
				], false, ''),
			new we_weTag_textAttribute('font', false, ''),
			new we_weTag_selectorAttribute('fontpath', FILE_TABLE, we_weTag_selectorAttribute::FOLDER, false, '', true),
			new we_weTag_selectAttribute('case', [
				new we_weTag_option('mix'),
				new we_weTag_option('upper'),
				new we_weTag_option('lower'),
				], false, ''),
			new we_weTag_selectAttribute('type', [
				new we_weTag_option('gif'),
				new we_weTag_option('jpg'),
				new we_weTag_option('png'),
				], false, ''),
			new we_weTag_textAttribute('stylenumber', false, ''),
			new we_weTag_textAttribute('alt', false, ''),
		];
	}

}
