<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 02a1ba0c8f01 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-08-12 16:37 +0200 $
 */
class we_tw_category extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName, true);

		$this->NeedsEndTag = false;
		$this->Module = we_modules_info::CATEGORY;

		$this->Attributes = [
			new we_weTag_textAttribute('delimiter', false, ''),
			new we_weTag_selectAttribute('doc', [new we_weTag_option('self'),
				new we_weTag_option('top'),
				new we_weTag_option('listview'),
				], false, ''),
			new we_weTag_selectAttribute('showpath', we_weTag_selectAttribute::getTrueFalse()),
			new we_weTag_selectorAttribute('rootdir', CATEGORY_TABLE, '', false, '', true),
			new we_weTag_selectAttribute('field', [
				new we_weTag_option('ID'),
				new we_weTag_option('ParentID'),
				new we_weTag_option('Text'),
				new we_weTag_option('Path'),
				new we_weTag_option('Title'),
				new we_weTag_option('Description'),
				], false, ''),
			new we_weTag_textAttribute('onlyindir', false, ''),
			new we_weTag_selectorAttribute('id', CATEGORY_TABLE, ''),
			new we_weTag_textAttribute('separator', false, ''),
			new we_weTag_textAttribute('name', false, ''),
			new we_weTag_selectAttribute('multiple', we_weTag_selectAttribute::getTrueFalse())
		];
	}

}
