<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: 4571e7be0153 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-08-21 13:49 +0200 $
 */
class we_tw_delete extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName, true);
		$this->NeedsEndTag = false;

		$id = new we_weTag_textAttribute('id', false, '');
		$doctype = new we_weTag_sqlRowAttribute('doctype', DOC_TYPES_TABLE, false, 'Text');
		$docTyppeIds = new we_weTag_sqlRowAttribute('doctypeIDs', DOC_TYPES_TABLE, false);
		$classid = new we_weTag_selectorAttribute('classid', OBJECT_TABLE, we_base_ContentTypes::OBJECT, false, we_modules_info::OBJECT);
		$pid = new we_weTag_selectorAttribute('pid', FILE_TABLE, we_weTag_selectorAttribute::FOLDER, false, '');
		$pidO = new we_weTag_selectorAttribute('pid', OBJECT_FILES_TABLE, we_weTag_selectorAttribute::FOLDER, false, we_modules_info::OBJECT);
		$protected = new we_weTag_selectAttribute('protected', we_weTag_selectAttribute::getTrueFalse());
		$admin = new we_weTag_textAttribute('admin', false, '');
		$forceedit = new we_weTag_selectAttribute('forceedit', we_weTag_selectAttribute::getTrueFalse());
		$mail = new we_weTag_textAttribute('mail', false, '');
		$mailfrom = new we_weTag_textAttribute('mailfrom', false, '');
		$userid = new we_weTag_textAttribute('userid', false, '');

		$this->TypeAttribute = new we_weTag_typeAttribute('type', [new we_weTag_option('document', false, '', [
				$doctype, $docTyppeIds,
				$pid, $userid, $admin, $forceedit, $mail, $mailfrom,
				$protected, $id
				], []),
			new we_weTag_option('object', false, '', [$classid, $userid, $admin, $forceedit, $mail, $mailfrom, $pidO, $protected, $id], [])], false, '');

		$this->Attributes = [$doctype, $docTyppeIds, $classid, $pid, $pidO, $protected, $admin, $forceedit, $mail, $mailfrom, $userid, $id];
	}

}
