<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: 02a1ba0c8f01 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-08-12 16:37 +0200 $
 */
class we_tw_ifShopVat extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName, true);
		$this->NeedsEndTag = true;
		$this->Groups = [self::GROUP_IF];
		$this->Module = we_modules_info::SHOP;

		if(we_modules_info::isActive(we_modules_info::SHOP)){
			$options = [new we_weTag_option('', 0)];
			$vats = we_shop_vats::getAllShopVATs();
			foreach($vats as $vat){
				$options[] = new we_weTag_option($vat->vat . '% - ' . $vat->getNaturalizedText() . ' (' . $vat->territory . ')', $vat->id);
			}

			if(!we_shop_category::isCategoryMode()){
				$this->Attributes = [
					new we_weTag_selectAttribute('id', $options, true)
				];
				return;
			}
			$this->Attributes = [
				new we_weTag_selectAttribute('field', [new we_weTag_option('id'),
					new we_weTag_option('is_standard'),
					new we_weTag_option('is_fallback_to_standard'),
					new we_weTag_option('is_fallback_to_prefs'),
					new we_weTag_option('is_country_fallback_to_prefs')
					], false, ''),
				new we_weTag_selectAttribute('match', $options, false)
			];
		}
	}

}
