<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: 02a1ba0c8f01 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-08-12 16:37 +0200 $
 */
class we_tw_ifVar extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName, true);
		$this->NeedsEndTag = true;
		$this->Groups = [self::GROUP_IF];

		$this->Attributes = [
			new we_weTag_textAttribute('name', true, ''),
			new we_weTag_textAttribute('match', true, ''),
			new we_weTag_selectAttribute('type', [
				new we_weTag_option('global'),
				new we_weTag_option('request'),
				new we_weTag_option('post'),
				new we_weTag_option('get'),
				new we_weTag_option('cookie'),
				new we_weTag_option('document'),
				new we_weTag_option('property'),
				new we_weTag_option('session'),
				new we_weTag_option('sessionfield'),
				], false, ''),
			new we_weTag_selectAttribute('doc', [
				new we_weTag_option('self'),
				new we_weTag_option('top'),
				], false, ''),
			new we_weTag_selectAttribute('operator', [
				new we_weTag_option('equal'),
				new we_weTag_option('less'),
				new we_weTag_option('less|equal'),
				new we_weTag_option('greater'),
				new we_weTag_option('greater|equal'),
				new we_weTag_option('contains'),
				new we_weTag_option('isin'),
				], false, ''),
		];
	}

}
