<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: c564388e074d $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-07-17 13:01 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_weTag_ifNotTag extends we_weTag_tag{

	/**
	 * @param array<string,mixed> $attribs parsed tag-attributes
	 * @param string $content content between openingtag and closing tag
	 * @return string parsed tag for php
	 */
	public static function parse(array $attribs, string $content): string{
		$tagname = strtr(get_called_class(), ['we_tag_ifNot' => 'if']);
		/* if(!isset($endeEndTagPos)){
		  return self::parseError(sprintf(g_l('parser', '[selfclosingIf]'), $tagname), $tag);
		  } */
		return '<?php if(!' . we_weTag_parser::printTag($tagname, $attribs) . '){ ?>' . $content . '<?php } ?>';
	}

	/**
	 * @param array<string,mixed> $attribs parsed tag-attributes
	 * @param string $content content between openingtag and closing tag
	 * @param bool $internal if used by we internally
	 * @throws we_exception_parser if any attribute is missing
	 */
	public static function tag(array $attribs = [], string $content = '', bool $internal = false): bool{
		$tagname = strtr(get_called_class(), ['we_tag_ifNot' => 'if']);
		if(isset($attribs['_name_orig'])){
			$attribs['name'] = $attribs['_name_orig'];
		}
		return !we_weTag_util::tag($tagname, $attribs);
	}

}
