/* global WE, top */

/**
 * webEdition CMS
 *
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';

WE().util.loadConsts(document, "g_l.backupWizard");
var backup = WE().util.getDynamicVar(document, 'loadVarBackup_wizard', 'data-backup');

function we_submitForm(target, url) {
	var f = window.document.we_form;
	if (!f.checkValidity()) {
		WE().util.showMessage(WE().consts.g_l.main.save_error_fields_value_not_valid, WE().consts.message.WE_MESSAGE_ERROR, window);
		return false;
	}
	f.target = target;
	f.action = url;
	f.method = "post";
	f.submit();
	return true;
}

function doClicked(checked, opt) {
	if (checked) {

		switch (opt) {
			case 101:
				if (!document.we_form.handle_core.checked) {
					document.we_form.handle_core.value = 1;
					document.we_form.handle_core.checked = true;
					WE().util.showMessage(WE().consts.g_l.backupWizard[backup.mode].temporary_dep, WE().consts.message.WE_MESSAGE_NOTICE, window);
				}
				break;
			case 12:
				if (!document.we_form.handle_core.checked || !document.we_form.handle_object.checked) {
					document.we_form.handle_core.value = 1;
					document.we_form.handle_core.checked = true;
					document.we_form.handle_object.value = 1;
					document.we_form.handle_object.checked = true;
					WE().util.showMessage(WE().consts.g_l.backupWizard[backup.mode].versions_dep, WE().consts.message.WE_MESSAGE_NOTICE, window);
				}
				break;
			case 13:
				if (!document.we_form.handle_core.checked || !document.we_form.handle_object.checked || !document.we_form.handle_versions.checked) {
					document.we_form.handle_core.value = 1;
					document.we_form.handle_core.checked = true;
					document.we_form.handle_object.value = 1;
					document.we_form.handle_object.checked = true;
					document.we_form.handle_versions.value = 1;
					document.we_form.handle_versions.checked = true;
					WE().util.showMessage(WE().consts.g_l.backupWizard[backup.mode].versions_binarys_dep, WE().consts.message.WE_MESSAGE_NOTICE, window);
				}
				break;
			case 14:
				if (!document.we_form.handle_core.checked) {
					document.we_form.handle_core.value = 1;
					document.we_form.handle_core.checked = true;
					WE().util.showMessage(WE().consts.g_l.backupWizard[backup.mode].binary_dep, WE().consts.message.WE_MESSAGE_NOTICE, window);
				}
				break;
			case 55:
				if (!document.we_form.handle_core.checked || !document.we_form.handle_object.checked) {
					document.we_form.handle_core.value = 1;
					document.we_form.handle_core.checked = true;
					document.we_form.handle_object.value = 1;
					document.we_form.handle_object.checked = true;
					WE().util.showMessage(WE().consts.g_l.backupWizard[backup.mode].schedule_dep, WE().consts.message.WE_MESSAGE_NOTICE, window);
				}
				break;
			case 30:
				if (WE().consts.modules.active.indexOf("shop") !== -1 && WE().consts.modules.active.indexOf("customer") !== -1 && !document.we_form.handle_customer.checked) {
					document.we_form.handle_customer.value = 1;
					document.we_form.handle_customer.checked = true;
					WE().util.showMessage(WE().consts.g_l.backupWizard[backup.mode].shop_dep, WE().consts.message.WE_MESSAGE_NOTICE, window);
				}
				break;
			case 35:
				if (WE().consts.modules.active.indexOf("workflow") !== -1 && !document.we_form.handle_user.checked || !document.we_form.handle_core.checked) {
					document.we_form.handle_core.value = 1;
					document.we_form.handle_core.checked = true;
					document.we_form.handle_user.value = 1;
					document.we_form.handle_user.checked = true;
					WE().util.showMessage(WE().consts.g_l.backupWizard[backup.mode].workflow_dep, WE().consts.message.WE_MESSAGE_NOTICE, window);
				}
				break;
			case 45:
				if (WE().consts.modules.active.indexOf("newsletter") !== -1 && WE().consts.modules.active.indexOf("customer") !== -1 && !document.we_form.handle_customer.checked || !document.we_form.handle_core.checked || !document.we_form.handle_object.checked) {
					document.we_form.handle_core.value = 1;
					document.we_form.handle_core.checked = true;
					document.we_form.handle_object.value = 1;
					document.we_form.handle_object.checked = true;
					document.we_form.handle_customer.value = 1;
					document.we_form.handle_customer.checked = true;
					WE().util.showMessage(WE().consts.g_l.backupWizard[backup.mode].newsletter_dep, WE().consts.message.WE_MESSAGE_NOTICE, window);
				}
				break;

		}
		return;
	}
	var mess = "",
		tmpMess;
	switch (opt) {
		case 10:
			if (WE().consts.modules.active.indexOf("workflow") !== -1 && document.we_form.elements.handle_workflow.checked) {
				document.we_form.elements.handle_workflow.checked = false;
				mess += "\n-" + WE().consts.g_l.backupWizard[backup.mode].workflow_data;
			}
			if (WE().consts.modules.active.indexOf("newsletter") !== -1 && document.we_form.elements.handle_newsletter.checked) {
				document.we_form.elements.handle_newsletter.checked = false;
				mess += "\n-" + WE().consts.g_l.backupWizard[backup.mode].newsletter_data;
			}
			if (WE().consts.modules.active.indexOf("schedule") !== -1 && document.we_form.elements.handle_schedule.checked) {
				document.we_form.elements.handle_schedule.checked = false;
				mess += "\n-" + WE().consts.g_l.backupWizard[backup.mode].schedule_data;
			}
			if (document.we_form.elements.handle_versions.checked) {
				document.we_form.elements.handle_versions.checked = false;
				mess += "\n-" + WE().consts.g_l.backupWizard[backup.mode].versions_data;
			}

			if (document.we_form.elements.handle_versions_binarys.checked) {
				document.we_form.elements.handle_versions_binarys.checked = false;
				mess += "\n-" + WE().consts.g_l.backupWizard[backup.mode].versions_binarys_data;
			}
			if (document.we_form.elements.handle_temporary.checked) {
				document.we_form.elements.handle_temporary.checked = false;
				mess += "\n-" + WE().consts.g_l.backupWizard[backup.mode].temporary_data;
			}
			if (document.we_form.elements.handle_history.checked) {
				document.we_form.elements.handle_history.checked = false;
				mess += "\n-" + WE().consts.g_l.backupWizard[backup.mode].history_data;
			}
			if (mess !== "") {
				tmpMess = WE().util.sprintf(WE().consts.g_l.backupWizard.unselect_dep2, WE().consts.g_l.backupWizard[backup.mode].core_data) + mess + "\n" + WE().consts.g_l.backupWizard.unselect_dep3;
				WE().util.showMessage(tmpMess, WE().consts.message.WE_MESSAGE_NOTICE, window);
			}
			break;

		case 11:
			if (WE().consts.modules.active.indexOf("object") !== -1) {
				if (WE().consts.modules.active.indexOf("schedule") !== -1 && document.we_form.elements.handle_schedule.checked) {
					document.we_form.elements.handle_schedule.checked = false;
					mess += "\n-" + WE().consts.g_l.backupWizard[backup.mode].schedule_data;
				}
				if (document.we_form.elements.handle_versions.checked) {
					document.we_form.elements.handle_versions.checked = false;
					mess += "\n-" + WE().consts.g_l.backupWizard[backup.mode].versions_data;
				}
				if (document.we_form.elements.handle_versions_binarys.checked) {
					document.we_form.elements.handle_versions_binarys.checked = false;
					mess += "\n-" + WE().consts.g_l.backupWizard[backup.mode].versions_binarys_data;
				}
				if (mess !== "") {
					tmpMess = WE().util.sprintf(WE().consts.g_l.backupWizard.unselect_dep2, WE().consts.g_l.backupWizard[backup.mode].object_data) + mess + "\n" + WE().consts.g_l.backupWizard.unselect_dep3;
					WE().util.showMessage(tmpMess, WE().consts.message.WE_MESSAGE_NOTICE, window);
				}
			}
			break;
		case 12:
			if (WE().consts.modules.active.indexOf("object") !== -1) {
				if (document.we_form.elements.handle_versions_binarys.checked) {
					document.we_form.elements.handle_versions_binarys.checked = false;
					mess += "\n-" + WE().consts.g_l.backupWizard[backup.mode].versions_binarys_data;
				}
				if (mess !== "") {
					tmpMess = WE().util.sprintf(WE().consts.g_l.backupWizard.unselect_dep2, WE().consts.g_l.backupWizard[backup.mode].versions_data) + mess + "\n" + WE().consts.g_l.backupWizard.unselect_dep3;
					WE().util.showMessage(tmpMess, WE().consts.message.WE_MESSAGE_NOTICE, window);
				}
			}
			break;

		case 14:
			if (mess !== "") {
				tmpMess = WE().util.sprintf(WE().consts.g_l.backupWizard.unselect_dep2, WE().consts.g_l.backupWizard[backup.mode].binary_data) + mess + "\n" + WE().consts.g_l.backupWizard.unselect_dep3;
				WE().util.showMessage(tmpMess, WE().consts.message.WE_MESSAGE_NOTICE, window);
			}
			break;
		case 20:
			if (WE().consts.modules.active.indexOf("workflow") !== -1) {
				if (document.we_form.elements.handle_workflow.checked) {
					document.we_form.elements.handle_workflow.checked = false;
					mess += "\n-" + WE().consts.g_l.backupWizard[backup.mode].workflow_data;
				}

				if (mess !== "") {
					tmpMess = WE().util.sprintf(WE().consts.g_l.backupWizard.unselect_dep2, WE().consts.g_l.backupWizard[backup.mode].user_data) + mess + "\n" + WE().consts.g_l.backupWizard.unselect_dep3;
					WE().util.showMessage(tmpMess, WE().consts.message.WE_MESSAGE_NOTICE, window);
				}
			}
			break;
		case 25:
			if (WE().consts.modules.active.indexOf("customer") !== -1) {
				if (WE().consts.modules.active.indexOf("shop") !== -1 && document.we_form.elements.handle_shop.checked) {
					document.we_form.elements.handle_shop.checked = false;
					mess += "\n-" + WE().consts.g_l.backupWizard[backup.mode].shop_data;
				}
				if (WE().consts.modules.active.indexOf("newsletter") !== -1 && document.we_form.elements.handle_newsletter.checked) {
					document.we_form.elements.handle_newsletter.checked = false;
					mess += "\n-" + WE().consts.g_l.backupWizard[backup.mode].newsletter_data;
				}
				if (mess !== "") {
					tmpMess = WE().util.sprintf(WE().consts.g_l.backupWizard.unselect_dep2, WE().consts.g_l.backupWizard[backup.mode].customer_data) + mess + "\n" + WE().consts.g_l.backupWizard.unselect_dep3;
					WE().util.showMessage(tmpMess, WE().consts.message.WE_MESSAGE_NOTICE, window);
				}
			}
			break;
	}
}

function delSelItem() {
	var sel = document.we_form.backup_select;
	if (sel.selectedIndex > -1) {
		sel.remove(sel.selectedIndex);
	}
}

function showAll() {
	var
		a = document.we_form.backup_select.options,
		b = document.we_form.show_all,
		i, j;

	if (b.checked) {
		b.value = 1;
		for (i = 0; i < backup.extra_files.length; i++) {
			a[a.length] = new window.Option(backup.extra_files_desc[i], backup.extra_files[i]);
		}
	} else {
		b.value = 0;
		for (i = a.length - 1; i > -1; i--) {
			for (j = backup.extra_files.length - 1; j > -1; j--) {
				if (a[i].value === backup.extra_files[j]) {
					a[i] = null;
					break;
				}
			}
		}
	}
}

function setLocation(loc) {
	if (WE().util.dialogTop(window).cmd.reloadTimer) {
		window.clearTimeout(WE().util.dialogTop(window).cmd.reloadTimer);
	}

	document.location.href = loc;
}

function startStep(step, doImport) {
	window.focus();
	WE().util.dialogTop(window).busy.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=" + backup.modeCmd + "&pnt=busy&step=" + step + (
		doImport !== undefined ? "&do_import_after_backup=" + doImport : "");
}

function startBusy() {
	WE().util.dialogTop(window).busy.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=" + backup.modeCmd + "&pnt=busy&operation_mode=busy&step=4";
}

function stopBusy() {
	WE().util.dialogTop(window).busy.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=" + backup.modeCmd + "&pnt=busy&step=5";
	WE().util.dialogTop(window).cmd.location = "about:blank";
	window.focus();
}

function delOldFiles() {
	WE().util.showConfirm(window, "", WE().consts.g_l.backupWizard.delold_confirm, ["deleteOldFiles",
		WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=" + backup.modeCmd + "&pnt=cmd&operation_mode=deleteall"]);
}

function delSelected() {
	var sel = document.we_form.backup_select;
	if (sel.selectedIndex > -1) {
		WE().util.showConfirm(window, "", WE().consts.g_l.backupWizard.delold_confirm, ["delSelectedDo",
			WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=" + backup.modeCmd + "&pnt=cmd&operation_mode=deletebackup&bfile=" + sel.options[sel.selectedIndex].value]);
	} else {
		WE().util.showMessage(WE().consts.g_l.backupWizard.nothing_selected_fromlist, WE().consts.message.WE_MESSAGE_WARNING, window);
	}
}

function startImport() {
	var
		frameId,
		_usedEditors = WE().layout.weEditorFrameController.getEditorsInUse();

	if (WE().util.dialogTop(window).edbody.weFileUpload_instance) {
		if (WE().util.dialogTop(window).edbody.weFileUpload_instance.getUploaderState() !== 'finished') {
			WE().util.dialogTop(window).edbody.weFileUpload_instance.checkStartUpload('fileupload_startImport');
			return;
		}

		for (frameId in _usedEditors) {
			_usedEditors[frameId].setEditorIsHot(false);
		}
		WE().layout.weEditorFrameController.closeAllDocuments();

		startBusy();
		WE().util.dialogTop(window).edbody.delete_enabled = WE().layout.button.switch_button_state(WE().util.dialogTop(window).edbody.document, "delete", "disabled");
		document.we_form.action = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_backup_cmd";
		document.we_form.submit();
	} else {
		if (document.we_form.backup_select.value) {
			for (frameId in _usedEditors) {
				_usedEditors[frameId].setEditorIsHot(false);
			}
			WE().layout.weEditorFrameController.closeAllDocuments();

			startBusy();
			WE().util.dialogTop(window).edbody.delete_backup_enabled = WE().layout.button.switch_button_state(WE().util.dialogTop(window).edbody.document, "delete_backup", "disabled");
			WE().util.dialogTop(window).edbody.delete_enabled = WE().layout.button.switch_button_state(WE().util.dialogTop(window).edbody.document, "delete", "disabled");
			document.we_form.action = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_backup_cmd";
			document.we_form.submit();
		} else {
			WE().util.showMessage(WE().consts.g_l.backupWizard.nothing_selected_fromlist, WE().consts.message.WE_MESSAGE_WARNING, window);
		}
	}
}

function doCheck(opt) {
	if (backup.form_properties[opt]) {
		document.we_form[backup.form_properties[opt]].checked = true;
		doClick(opt);
	}
}

function doUnCheck(opt) {
	if (backup.form_properties[opt]) {
		document.we_form[backup.form_properties[opt]].checked = false;
		doClick(opt);
	}
}

function doClick(opt) {
	if (backup.form_properties[opt]) {
		var a = document.we_form[backup.form_properties[opt]];
		doClicked(a.checked, opt);
		if (!a.checked) {

		}
	}
}

function reloadFrame() {
	if (backup.reload < 3) {
		WE().util.dialogTop(window).cmd.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_backup_cmd&cmd=" + backup.mode + "&reload=" + backup.reload;
	} else {
		WE().util.showMessage(WE().consts.g_l.backupWizard.error_timeout, WE().consts.message.WE_MESSAGE_ERROR, window);
	}
}

function run(type, percent, desc) {
	if (WE().util.dialogTop(window).cmd.reloadTimer) {
		clearTimeout(WE().util.dialogTop(window).cmd.reloadTimer);
	}
	updateProgress(percent, desc);
	WE().util.dialogTop(window).cmd.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_backup_cmd&cmd=" + type;
}

function updateProgress(percent, desc) {
	if (WE().util.dialogTop(window).busy && WE().util.dialogTop(window).busy.setProgressText) {
		WE().util.dialogTop(window).busy.setProgressText("current_description", desc);
		WE().util.dialogTop(window).busy.setProgress(percent);
	}
}

function backupFinished(text) {
	updateProgress(100, text);
	WE().util.dialogTop(window).edbody.setLocation(WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=make_backup&pnt=edbody&step=2");
	WE().util.dialogTop(window).cmd.location = "about:blank";
}

function we_cmd() {
	/*jshint validthis:true */
	var caller = (this && this.window === this ? this : window),
		args = WE().util.getWe_cmdArgsArray(Array.prototype.slice.call(arguments));
	//var url = WE().util.getWe_cmdArgsUrl(args);

	switch (args[0]) {
		case "rebuild":
			new (WE().layout.overlay)(WE().util.dialogTop(window).opener, WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=rebuild&step=2&btype=rebuild_all&responseText=" + WE().consts.g_l.backupWizard.finished_success, "rebuildwin", WE().consts.size.dialog.small, WE().consts.size.dialog.tiny, false, false, '', true, 'top');
			WE().util.dialogTop(window).doClose();
			break;
		case "deleteall":
			(new (WE().layout.overlay)(window, 'top', WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=delFrag&currentID=-1", "we_del", WE().consts.size.dialog.small, WE().consts.size.dialog.tiny)).open();
			break;
		case "delSelectedDo":
		case "deleteOldFiles":
			WE().util.dialogTop(window).cmd.location = args[1];
			break;
		case "deletebackup":
			if (WE().util.dialogTop(window).edbody.delSelItem) {
				WE().util.dialogTop(window).edbody.delSelItem();
			}
			break;
		case "importFinished":
			finishedImport(args[1].doRebuild, args[1].file);
			break;
		case "import_file_found":
			WE().util.showConfirm(window, "", WE().consts.g_l.backupWizard.import_file_found, ["import_file_found_doImport"], ["import_file_found_doRecover"]);
			break;
		case "import_file_found_doImport":
			WE().util.dialogTop(window).opener.top.we_cmd("import");
			WE().util.dialogTop(window).doClose();
			break;
		case "import_file_found_doRecover":
			WE().util.dialogTop(window).edbody.location = WE().consts.dirs + "we_cmd.php?we_cmd[0]=recover_backup&pnt=edbody&step=2";
			break;
		case "fileupload_startImport": //is this needed???
			startImport();
			break;
		default:
			WE().util.dialogTop(window).opener.we_cmd.apply(caller, Array.prototype.slice.call(arguments));
	}
}

function finishedImport(doRebuild, file) {
	WE().util.dialogTop(window).opener.top.we_cmd("load", WE().util.dialogTop(window).opener.top.treeData.table);
	WE().util.dialogTop(window).busy.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=recover_backup&pnt=busy&operation_mode=busy&percent=100&current_description=" + WE().consts.g_l.backupWizard.finished;
	if (doRebuild) {
		WE().util.dialogTop(window).cmd.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=recover_backup&pnt=cmd&operation_mode=rebuild";
	} else {
		WE().util.dialogTop(window).edbody.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=recover_backup&pnt=edbody&step=4&temp_filename=" + file;
	}
	if (WE().util.dialogTop(window).busy && WE().util.dialogTop(window).busy.setProgressText) {
		WE().util.dialogTop(window).busy.setProgressText("current_description", WE().consts.g_l.backupWizard.finished);
		WE().util.dialogTop(window).busy.setProgress(100);
	}
}

//add reload timer if set
if (backup && backup.reloadTimer) {
	if (WE().util.dialogTop(window).cmd.reloadTimer) {
		clearTimeout(WE().util.dialogTop(window).cmd.reloadTimer);
	}

	WE().util.dialogTop(window).cmd.reloadTimer = setTimeout(reloadFrame, backup.reloadTimer);
}
