/* global WE, top */

/**
 * webEdition SDK
 *
 * webEdition CMS
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 *
 * This source is part of the webEdition SDK. The webEdition SDK is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU Lesser General Public License can be found at
 * http://www.gnu.org/licenses/lgpl-3.0.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionSDK/License.txt
 *
 *
 * @license    http://www.gnu.org/licenses/lgpl-3.0.html  LGPL
 */
'use strict';
var
	editor = WE().util.getDynamicVar(document, 'loadVarFileupload_ui_editor', 'data-editor'),
	categories_edit = null;

$(function () {
	initCat();
});

function we_cmd() {
	/*jshint validthis:true */
	var caller = (this && this.window === this ? this : window),
		args = WE().util.getWe_cmdArgsArray(Array.prototype.slice.call(arguments)),
		url = WE().util.getWe_cmdArgsUrl(args);

	switch (args[0]) {
		case 'we_selector_document':
		case 'we_selector_image':
		case 'we_selector_directory':
			(new (WE().layout.overlay)(caller, 'top', url, 'we_fileselector', WE().consts.size.dialog.big, WE().consts.size.dialog.medium)).setResizeable().open();
			break;
		case "addCat":
			addCat(args[1].allPaths);
			break;
		case "setFocus":
			var elem = document.forms[0].elements[args[1]];
			elem.focus();
			elem.select();
			break;
		case 'close':
			WE().util.dialogTop(window).doClose();
			break;
		default :
			WE().util.dialogTop(window).opener.we_cmd.apply(caller, Array.prototype.slice.call(arguments));
			break;
	}
}

function initCat() {
	if (!document.we_form.fu_doc_categories) {
		return;
	}
	categories_edit = new (WE().util.multi_edit)("categoriesDiv", window, 0, editor.trashButton, 400, false, '', WE().consts.contentTypes.CATEGORY);
	categories_edit.addVariant();
	document.we_form.fu_doc_categories.value = categories_edit.name;
	categories_edit.showVariant(0);
}

function removeAllCats() {
	if (!categories_edit) {//cats disabled
		return;
	}
	if (categories_edit.itemCount > 0) {
		while (categories_edit.itemCount > 0) {
			categories_edit.delItem(categories_edit.itemCount);
		}
		categories_edit.showVariant(0);
		selectCategories();
	}
}

function addCat(paths) {
	if (!categories_edit) {//cats disabled
		return;
	}
	for (var i = 0; i < paths.length; i++) {
		if (paths[i] !== "") {
			categories_edit.addItem();
			categories_edit.setItem(0, (categories_edit.itemCount - 1), paths[i]);
		}
	}
	categories_edit.showVariant(0);
	selectCategories();
}

function selectCategories() {
	if (!categories_edit) {//cats disabled
		return;
	}
	var cats = [];
	for (var i = 0; i < categories_edit.itemCount; i++) {
		cats.push(categories_edit.form.elements[categories_edit.name + "_variant0_" + categories_edit.name + "_item" + i].value);
	}
	categories_edit.form.fu_doc_categories.value = cats.join(",");
}
