/* global top, WE, fileSelect, entries,getEntry,writeBodyDir */

/**
 * webEdition CMS
 *
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';

function selectFile(id) {
	var a = WE().util.dialogTop(window).document.getElementsByName("fname")[0];
	if (id) {
		var e = getEntry(id);
		if (a.value != e.text &&
			a.value.indexOf(e.text + ",") === -1 &&
			a.value.indexOf("," + e.text + ",") === -1 &&
			a.value.indexOf("," + e.text + ",") === -1) {

			a.value = a.value ?
				(a.value + "," + e.text) :
				e.text;

			var show = WE().util.dialogTop(window).document.getElementById("showDiv");
			if (show) {
				show.innerHTML = WE().util.dialogTop(window).document.getElementsByName("fname")[0].value;
			}

		}
		if (WE().util.dialogTop(window).fsbody.document.getElementById("line_" + id)) {
			WE().util.dialogTop(window).fsbody.document.getElementById("line_" + id).classList.add("selected");
		}
		WE().util.dialogTop(window).fileSelect.data.currentPath = e.path;
		WE().util.dialogTop(window).fileSelect.data.currentID = id;
	} else {
		WE().util.dialogTop(window).document.getElementsByName("fname")[0].value = "";
		WE().util.dialogTop(window).fileSelect.data.currentPath = "";
	}
}

function addEntry(ID, text, isFolder, path) {
	entries.push({
		ID: ID,
		text: text,
		isFolder: isFolder,
		path: path,
		contentType: (isFolder ? WE().consts.contentTypes.FOLDER_COMMON : WE().consts.contentTypes.NAVIGATION)
	});
}

function writeBody(d) {
	writeBodyDir(d, WE().consts.g_l.fileselector.newFolderNavigation, false);
}

function queryString(what, id) {
	return WE().util.dialogTop(window).fileSelect.options.formtarget +
		'&we_cmd[what]=' + what +
		'&we_cmd[rootDirID]=' + WE().util.dialogTop(window).fileSelect.options.rootDirID +
		'&we_cmd[open_doc]=' + WE().util.dialogTop(window).fileSelect.options.open_doc +
		'&we_cmd[table]=' + WE().util.dialogTop(window).fileSelect.options.table +
		'&we_cmd[id]=' + id;
}
