/**
 * webEdition CMS
 *
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

/* global top, WE */
'use strict';

var settings = WE().util.getDynamicVar(document, 'loadVarCustomer_sortAdmin', 'data-settings');

function doUnload() {
	WE().layout.jsWindow.prototype.closeAll(window);
}

function we_cmd() {
	/*jshint validthis:true */
	var caller = (this && this.window === this ? this : window),
		args = WE().util.getWe_cmdArgsArray(Array.prototype.slice.call(arguments));

	switch (args[0]) {
		case "add_sort_field":
			if (args[1] === "") {
				WE().util.showMessage(WE().consts.g_l.customer.sortAdmin.sortname_empty, WE().consts.message.WE_MESSAGE_ERROR, window);
				break;
			}
			document.we_form.sortindex.value = args[1];
			/* falls through */
		case "add_sort":
			document.we_form.cmd.value = args[0];
			submitForm();
			break;
		case "del_sort_field":
			document.we_form.fieldindex.value = args[2];
			/* falls through */
		case "del_sort":
			if (args[1] === settings.default_sort_view) {
				WE().util.showMessage(WE().consts.g_l.customer.sortAdmin.default_soting_no_del, WE().consts.message.WE_MESSAGE_ERROR, window);
			} else {
				document.we_form.cmd.value = args[0];
				document.we_form.sortindex.value = args[1];
				submitForm();
			}
			break;
		case "setSorts":
			var selected = WE().util.dialogTop(window).opener.top.content.document.we_form_treeheader.sort.selectedIndex;
			WE().util.dialogTop(window).opener.top.content.document.we_form_treeheader.sort.options.length = 0;
			for (var i = 0; i < args[1].length; i++) {
				WE().util.dialogTop(window).opener.top.content.addSorting(args[1][i]);
			}

			if (selected < WE().util.dialogTop(window).opener.top.content.document.we_form_treeheader.sort.options.length) {
				WE().util.dialogTop(window).opener.top.content.document.we_form_treeheader.sort.selectedIndex = selected;
			} else {
				WE().util.dialogTop(window).opener.top.content.document.we_form_treeheader.sort.selectedIndex = WE().util.dialogTop(window).opener.top.content.document.we_form_treeheader.sort.options.length - 1;
			}

			WE().util.dialogTop(window).opener.top.content.applySort();
			WE().util.dialogTop(window).doClose();
			break;
		case "save_sort":
		case "selectBranch":
			document.we_form.cmd.value = args[0];
			submitForm();
			break;
		default:
			top.content.we_cmd.apply(caller, Array.prototype.slice.call(arguments));

	}
	setScrollTo();
}


function doScrollTo() {
	if (WE().util.dialogTop(window).opener.top.content.scrollToVal) {
		window.scrollTo(0, WE().util.dialogTop(window).opener.top.content.scrollToVal);
		WE().util.dialogTop(window).opener.top.content.scrollToVal = 0;
	}
}

function setScrollTo() {
	WE().util.dialogTop(window).opener.top.content.scrollToVal = window.pageYOffset;
}

function submitForm(target, action, method, form) {
	var f = form ? window.document.forms[form] : window.document.we_form;
	f.target = target ? target : "sort_admin";
	f.action = action ? action : WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_showMod&mod=customer";
	f.method = method ? method : "post";

	f.submit();
}