/* global top, WE, treeData, container,drawTree,startTree,Node*/

/**
 * webEdition SDK
 *
 * webEdition CMS
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 *
 * This source is part of the webEdition SDK. The webEdition SDK is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU Lesser General Public License can be found at
 * http://www.gnu.org/licenses/lgpl-3.0.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionSDK/License.txt
 *
 *
 * @license    http://www.gnu.org/licenses/lgpl-3.0.html  LGPL
 */
'use strict';

container.prototype.reloadGroup = function (pid, offset) {
	var it = this.get(pid);
	if (it) {
		var openFolders = this.getOpenFolders(pid);
		it.clear();
		startTree(pid, (offset ? offset : 0), openFolders);
	}
};

container.prototype.getOpenFolders = function (pid) {
	pid = parseInt(pid);
	var index = this.indexOfEntry(pid);

	if (index !== -1) {
		var openFolders = [];
		var parentPath = pid !== 0 ? this.elements[index].path : '/';

		for (var i = 1; i <= this.len; i++) {
			if (parseInt(this.elements[i].id) !== 0 &&
				parseInt(this.elements[i].id) !== pid &&
				this.elements[i].path && // newly added folders have no path property yet
				this.elements[i].path.indexOf(parentPath) === 0 &&
				this.elements[i].open === 1) {
				openFolders.push(this.elements[i].id);
			}
		}

		return openFolders;
	}

	return [];
};

Node.prototype.showSegment = function () {
	reloadGroup(this.parentid, this.offset);
};

function info(text) {
	var i = top.content.document.getElementById("infoField");
	var s = top.content.document.getElementById("search");
	if (text !== " ") {
		s.style.display = "none";
		i.style.display = "block";
		i.innerHTML = text;
	} else {
		i.innerHTML = text;
		i.style.display = "none";
		s.style.display = "block";
	}
}

container.prototype.addSort = function (object) {
	this.len++;
	for (var i = this.len; i > 0; i--) {
		if (i > 1 && (this[i - 1].order > object.order)) {
			this[i] = this[i - 1];
			continue;
		}
		for (var j = i; j > 0; j--) {
			if (j > 1 && (this[j - 1].order === object.order) && (this[j - 1].text.toLowerCase() > object.text.toLowerCase() || (this[j - 1].typ > object.typ))) {
				this[j] = this[j - 1];
			} else {
				this[j] = object;
				break;
			}
		}
		break;
	}
};

container.prototype.doClick = function (id) {
	var node = this.get(id);
	top.content.editor.edbody.we_cmd("we_navigation_edit", node.id);
};
