/* global tinymce */

/**
 * webEdition CMS
 *
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';

(function () {
	var wefullscreen = (function () {

		var global = tinymce.util.Tools.resolve('tinymce.PluginManager');

		var toggleFullscreenInlineTrue = function (editor) {
			// FIXME: create html on we_wysiwyg_editor and get it from editor.settings

			editor.execCommand('mceFullScreen');
			editor.settings.weIsFullscreen = !editor.settings.weIsFullscreen;
			editor.weControlManager.setActive('wefullscreen', editor.settings.weIsFullscreen);

			var headerContainer = editor.getContainer().firstChild;
			if (editor.settings.weIsFullscreen) {
				var headerDiv = document.createElement('DIV'),
					header = document.createElement('DIV'),
					btnRestore = document.createElement('SPAN'),
					btnClose = document.createElement('SPAN'),
					maskDiv = document.createElement('DIV'),
					footerDiv = document.createElement('DIV'),
					btnClose = document.createElement('BUTTON');

				headerDiv.className = 'headerDiv';
				header.className = 'header';
				btnRestore.className = 'btn btnRestore';
				btnRestore.innerHTML = '<i class="fa fa-window-restore fa-lg"></i>';
				btnRestore.addEventListener('mousedown', (toggleFullscreenInlineTrue.bind(this, editor)), true);
				/*
				 btnClose.className = 'btn btnClose';
				 btnClose.innerHTML = '<i class="fa fa-close fa-lg"></i>';
				 btnClose.addEventListener('mousedown', (toggleFullscreenInlineTrue.bind(this, editor)), true);
				 *
				 */

				headerDiv.appendChild(header);
				header.appendChild(btnRestore);
				//header.appendChild(btnClose);
				headerContainer.insertBefore(headerDiv, headerContainer.firstChild);

				editor.getContainer().classList.add('wysiwyg_weFullscreen');
				maskDiv.className = 'wysiwyg_fullscreenMask';
				maskDiv.id = 'wysiwygFullscreenMask';
				footerDiv.className = 'wysiwyg_editfooter';
				footerDiv.id = 'wysiwygFooterTmp';
				editor.getParam('weWin').document.body.appendChild(maskDiv);
				editor.getParam('weWin').document.body.appendChild(footerDiv);
				btnClose.className = 'weBtn  weIconTextButton';//weBtn  weIconTextButton weBtnClose
				btnClose.title = 'labla';
				btnClose.innerHTML = '<i class="fa fa-firsticon fa-lg fa-window-restore"></i><span class="text">Vollbild beenden</span>';
				btnClose.addEventListener('click', (toggleFullscreenInlineTrue.bind(this, editor)), true);
				footerDiv.appendChild(btnClose);
			} else {
				headerContainer.removeChild(headerContainer.firstChild);
				editor.getContainer().classList.remove('wysiwyg_weFullscreen');
				editor.getParam('weWin').document.body.removeChild(editor.getParam('weWin').document.getElementById('wysiwygFullscreenMask'));
				editor.getParam('weWin').document.body.removeChild(editor.getParam('weWin').document.getElementById('wysiwygFooterTmp'));
			}
		};

		var Commands = {register: function (editor) {
				editor.addCommand('mceWefullscreen', function () {
					switch (editor.settings.weEditorType) {
						case 'inlineFalse':
							WE().util.dialogTop(editor.settings.weWin).overlay.toggleFullscreen();
							break;
						default:
						case 'inlineTrue':
							toggleFullscreenInlineTrue(editor);
					}
				});
			}};

		var Buttons = {register: function (editor) {
				editor.ui.registry.addToggleButton('wefullscreen', {
					icon: 'fullscreen',
					tooltip: 'Fullscreen',
					onAction: function () {
						editor.execCommand('mceWefullscreen');
					},
					onSetup: function (buttonApi) {
						editor.weControlManager.register('button', 'wefullscreen', buttonApi);
					}
				});
			}};

		global.add('wefullscreen', function (editor) {
			Commands.register(editor);
			Buttons.register(editor);
			return {};
		});

		function Plugin() {}

		return Plugin;

	}());
})();
