/* global tinymce */

/**
 * webEdition CMS
 *
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';

(function () {
	var welink = (function () {

		var
			global = tinymce.util.Tools.resolve('tinymce.PluginManager'),
			open = function (ed, dropID) {
				dropID = dropID || 0;

				ed.isWeLinkInitialized = false;
				var c = ed.selection;
				if (c.isCollapsed() && !ed.dom.getParent(c.getNode(), "A")) {
					return;
				}
				var wehref = "";
				if (ed.dom.getParent(c.getNode(), 'A') !== null) {
					wehref = ed.dom.getParent(c.getNode(), 'A').href;
					if (dropID) {
						wehref = 'document:' + dropID; // replace existing paths by DnD!
					}
				} else if (dropID) {
					wehref = 'document:' + dropID;
				}

				ed.windowManager.openWePlugin({
					file: "/webEdition/we_cmd_frontend.php?we_cmd[0]=open_dialog_hyperlink&we_dialog_args[editor]=tinyMce&wysiwygInternalLink=" + encodeURIComponent(wehref) + "&we_dialog_args[href]=" + encodeURIComponent(wehref) + "&we_dialog_args[isFrontend]=" + ed.getParam('weIsFrontend'),
					width: 600,
					height: 600
				}, {
					plugin_url: ''//b
				});
			},
			Dialog = {open: open},
			Commands = {register: function (editor) {
					editor.addCommand('mceWelink', function (unknown, dropID) {
						Dialog.open(editor, dropID);
					});
				}},
			Buttons = {register: function (editor) {
					editor.ui.registry.addToggleButton('welink', {
						icon: 'link',
						tooltip: WE().consts.g_l.tinyMceTranslationObject.tt_welink,
						onAction: function () {
							editor.execCommand('mceWelink');
						},
						onSetup: function (buttonApi) {
							if (editor.dom.getParent(editor.selection.getNode(), 'A')) {
								buttonApi.setActive(true);
								buttonApi.setDisabled(false);
							} else {
								buttonApi.setDisabled(editor.selection.isCollapsed());
								buttonApi.setActive(false);
							}
						}
					});
					editor.ui.registry.addToggleButton('weunlink', {
						icon: 'unlink',
						tooltip: WE().consts.g_l.tinyMceTranslationObject.tt_weunlink,
						onAction: function () {
							editor.execCommand('unlink');
						},
						onSetup: function (buttonApi) {
							buttonApi.setActive(false);
							buttonApi.setDisabled(!editor.dom.getParent(editor.selection.getNode(), 'A'));
						}
					});
				}};

		global.add('welink', function (editor) {
			Commands.register(editor);
			Buttons.register(editor);
			return {};
		});

		function Plugin() {}

		return Plugin;

	}());
})();