/* global SXE, tinyMCEPopup */

/**
 * ins.js
 *
 * Copyright 2009, Moxiecode Systems AB
 * Released under LGPL License.
 *
 * License: http://tinymce.moxiecode.com/license
 * Contributing: http://tinymce.moxiecode.com/contributing
 */
'use strict';

var tinymcePlugin = window.tinyMCEPopup;

function init() {
	SXE.initElementDialog('ins');
	if (SXE.currentAction === "update") {
		setFormValue('datetime', tinymcePlugin.editor.dom.getAttrib(SXE.updateElement, 'datetime'));
		setFormValue('cite', tinymcePlugin.editor.dom.getAttrib(SXE.updateElement, 'cite'));
		SXE.disableRemoveButton(false);
	}
}

function setElementAttribs(elm) {
	setAllCommonAttribs(elm);
	setAttrib(elm, 'datetime');
	setAttrib(elm, 'cite');
	elm.removeAttribute('data-mce-new');
}

function insertIns() {
	var elm = tinymcePlugin.editor.dom.getParent(SXE.focusElement, 'INS');

	if (elm === null) {
		var s = SXE.inst.selection.getContent();
		if (s.length > 0) {
			insertInlineElement('ins');
			var elementArray = SXE.inst.dom.select('ins[data-mce-new]');
			for (var i = 0; i < elementArray.length; i++) {
				elm = elementArray[i];
				setElementAttribs(elm);
			}
		}
	} else {
		setElementAttribs(elm);
	}
	tinymcePlugin.editor.nodeChanged();
	tinymcePlugin.execCommand('mceEndUndoLevel');
}

function removeIns() {
	SXE.removeElement('ins');
}

function weTinyDialog_doOk() {
	insertIns();
	WE().util.dialogTop(window).doClose();
}

function weTinyDialog_doRemove() {
	removeIns();
	WE().util.dialogTop(window).doClose();
}

//window.tinyMCEPopup.onInit.add(init);
$(function () {
	init();
});
